$(function() {
	
	$(".btn-resource, .resource-link").off('click').on('click', function() {
		var prod_id = $(this).attr("data-prod-id");
		if (typeof prod_id !== 'undefined') {
			var amount_one = $(this).attr("data-amount-one");
				if (typeof amount_one === 'undefined') amount_one = '';
			var amount_two = $(this).attr("data-amount-two");
				if (typeof amount_two === 'undefined') amount_two = '';
			if (typeof prod_id === 'undefined') prod_id = 'NONE';
			premcheckout.show(prod_id, {'amount_one':amount_one, 'amount_two':amount_two});
			return false;
		}
	});	
	
	
	var premium = ((typeof getQueryStringValue('premium') !== 'undefined') ? getQueryStringValue('premium').toUpperCase() : '');
	var request = ((typeof getQueryStringValue('request') !== 'undefined') ? getQueryStringValue('request').toLowerCase() : '');
	if (premium!='') {
		var scrollto = ((typeof resourcedata !== 'undefined' && typeof resourcedata.resources!=='undefined' && resourcedata.resources[premium]!=='undefined' && typeof resourcedata.resources[premium].ScrollTo !== 'undefined') ? resourcedata.resources[premium].ScrollTo : '');
		if (scrollto!='') {
			if (request=='true') {
				setTimeout(function() {
					scrollToElem(scrollto, function() {
						premcheckout.show(premium);
					});					
				}, 250);
			}
			else {
				setTimeout(function() {
					scrollToElem(scrollto, function() {});	
				}, 250);
			}
		}
	}
	
});

var premcheckout = {};
premcheckout.data = {};
premcheckout.data.product_code = '';
premcheckout.data.min_amount = '';
premcheckout.data.amount = '';
premcheckout.data.receive_resources = null;
premcheckout.currency_selector = '<style>    .recurring_wrapper {     text-align: center;     margin: 20px 0;    }    .recurring_wrapper a {     text-decoration: none;     color: #333 !important;     font-weight: bold;    }    .recurring_wrapper a i {     position: relative;     bottom: -2px;            font-size: 1.2em;    }    .currencies_wrapper {     display: flex;     position: relative;     align-items: center;     justify-content: space-between;     border: 1px solid #ccc;     border-radius: 30px;     width: calc(90% - 32px);     max-width: 125px;     margin: 0 auto 20px auto;     padding: 7px 15px;     cursor: pointer;     color: #333;     z-index: 9;    }    .currencies_wrapper .label {     font-size: 14px;     width: calc(100% - 60px);    }    .currencies_wrapper > ul {     display: none;     position: absolute;     top: 34px;     left: 0;     width: calc(100% - 10px);     padding: 5px;     margin: 0;     border: 1px solid #ccc;     border-radius: 4px;     background: #fff;     font-size: 14px;     line-height: 1.4em;     list-style-type: none;    }    .currencies_wrapper > ul li a {     display: flex;     align-items: center;     justify-content: flex-start;     text-decoration: none;     color: #333 !important;     padding: 5px;     border-radius: 3px;     transition: all 0.25s ease;    }    .currencies_wrapper > ul li a:hover {     background: #e2e7ef;     transition: all 0.25s ease;    }    .currencies_wrapper > ul li a.selected {     background: #527ba9;     transition: all 0.25s ease;     color: #fff !important;           }    .currencies_wrapper > ul li a img {     display: block;      margin-right: 5px;    }    .currencies_wrapper img {     max-width: 30px;    }    .currencies_wrapper.show-dropdown > ul {     display: block;    }    .currencies_wrapper_bg {     position: fixed;     top: 0;     left: 0;     width: 100%;     height: 100%;     z-index: 1;    }    </style>    <div class="currencies_wrapper">     <div class="label">Currency</div>          <div class="selected-currency"><img src="https://d2urhn0mmik6is.cloudfront.net/site/donate/pure-gift/imgs/usflag.png" alt="USD" title="USD" /></div>     <i class="fa fa-caret-down" aria-hidden="true"></i>     <ul><li><a href="#" class="usd selected" data-currency="usd" data-currency-symbol="$" onclick="tp.selectCurrency(\'USD\', \'$\', premcheckout.updateCurrencyUi(this)); return false;"><img src="https://d2urhn0mmik6is.cloudfront.net/site/donate/pure-gift/imgs/usflag.png" alt="USD" title="USD" /> United States</a></li><li><a href="#" class="cad" data-currency="cad" data-currency-symbol="CAD $" onclick="tp.selectCurrency(\'CAD\', \'CAD $\', premcheckout.updateCurrencyUi(this)); return false;"><img src="https://d2urhn0mmik6is.cloudfront.net/site/donate/pure-gift/imgs/cadflag.png" alt="CAD" title="CAD" /> Canada</a></li><li><a href="#" class="gbp" data-currency="gbp" data-currency-symbol="&#163;" onclick="tp.selectCurrency(\'GBP\', \'&#163;\', premcheckout.updateCurrencyUi(this)); return false;"><img src="https://d2urhn0mmik6is.cloudfront.net/site/_images/header/flag_uk.png" alt="GBP" title="GBP" /> UK (GBP)</a></li></ul>    </div>     <script type="text/javascript">    $(function() {     $(".currencies_wrapper").off("click").on("click", function() {      tp.toggleCurrencyDropdown(this);      return false;     });    });    </script>';
premcheckout.data.overlay_title = '';
premcheckout.data.ProductName = '';


premcheckout.show = function(product_code, settings) {
	var visible = (( $('.checkout-overlay-wrapper').length>0 ) ? true : false);
	if (visible) return;
	
	if (typeof settings === 'undefined') settings = {};
	if (typeof settings.bypass_newbook_check === 'undefined') settings.bypass_newbook_check = false;
	
	//check for newbook products 
	if (!settings.bypass_newbook_check) {
		var is_newbook_product = premcheckout.isNewBookProduct(product_code);
		var cart_contains_newbook_product = premcheckout.doesCartContainNewBookProduct();
		var cart_contains_nonnewbook_product = premcheckout.doesCartContainNonNewBookProduct();
		if (is_newbook_product) {
			if (cart_contains_nonnewbook_product) {
				confirmDialog('<div style="font-family:\'Open Sans\', sans-serif;"><strong>Note:</strong> Items that are not part of <em>The Great Disappearance</em> series must be purchased separately and will be removed from your cart if you proceed.<div style="margin: 10px 0; font-size: 14px; border-top: 1px solid #e4e4e4; border-bottom: 1px solid #e4e4e4; padding: 10px 0;">For questions, please contact customer service headquarters Monday-Friday from 6:00AM-3:30PM PST at 1-877-998-0222 (from the telephone menu, select options 3 and then 5).</div><strong>Do you wish to proceed?</strong></div>', function() {
					tp.clearCartProducts(function() {
						premcheckout.show(product_code, {"bypass_newbook_check":true});
					});
				});
				return;
			}			
		}
		else {
			if (cart_contains_newbook_product) {
				confirmDialog('<div style="font-family:\'Open Sans\', sans-serif;"><strong>Note:</strong> All items that are from <em>The Great Disappearance</em> series must be purchased separately and will be removed from your cart if you proceed.<div style="margin: 10px 0; font-size: 14px; border-top: 1px solid #e4e4e4; border-bottom: 1px solid #e4e4e4; padding: 10px 0;">For questions, please contact customer service headquarters Monday-Friday from 6:00AM-3:30PM PST at 1-877-998-0222 (from the telephone menu, select options 3 and then 5).</div><strong>Do you wish to proceed?</strong></div>', function() {
					tp.clearCartProducts(function() {
						premcheckout.show(product_code, {"bypass_newbook_check":true});
					});
				});
				return;
			}
		}
	}
	
	premcheckout.clearData();
	
	var p = resourcedata.resources[product_code];
	premcheckout.data.product_code = product_code;
	premcheckout.data.min_amount = p.MinimumDonationAmount;
	
	var already_requested = false;
	//if (typeof mycart.cart.contents[product_code + '_PREMIUM'] !== 'undefined') {
		//console.log('already requested');
	//}
	
	var show_resource_options = true;
	if (typeof p.ShowResourceOptions !== 'undefined') {
		show_resource_options = p.ShowResourceOptions;
	}
	
	var currency_symbol = '$';
	if (typeof tp.currency_symbol !== 'undefined') {
		currency_symbol = tp.currency_symbol;
	}
	
	var html = '<div class="checkout-overlay-wrapper" data-product-code="{product_code}">' +
					'<div class="checkout-overlay-fg">' +
						'<div class="checkout-box">' +
							'<a href="#" class="btn-close" onclick="premcheckout.close(); return false;"><i class="fa fa-times" aria-hidden="true"></i></a>' +
							'<div class="title">' +
								'<h1>{overlay_title}</h1>' +
								'<h2>{overlay_subtitle}</h2>' +
							'</div>' +
							'<div class="error-msg"></div>' +
							'<div class="amount-boxes">' +
								'<div id="amount_box1" class="amount-box1" data-amount="{amount1}">' +
									'<i class="fa fa-check" aria-hidden="true"></i>' +
									'<span class="currency-symbol">' + currency_symbol + '</span><span class="amount-value">{amount1}</span>' +
									'<div class="currency-desc"></div>' +
								'</div>' +
								'<div id="amount_box2" class="amount-box2" data-amount="{amount2}">' +
									'<i class="fa fa-check" aria-hidden="true"></i>' +
									'<span class="currency-symbol">' + currency_symbol + '</span><span class="amount-value">{amount2}</span>' +
									'<div class="currency-desc"></div>' +
								'</div>' +
								'<div id="amount_box3" class="amount-box3">' +
									'<i class="fa fa-check" aria-hidden="true"></i>' +
									'<span class="currency-symbol">' + currency_symbol + '</span>' +
									'<input type="text" class="input-custom-amount" value="" />' +
									'<div class="currency-desc"></div>' +
								'</div>' +
							'</div>' +
							'{resource_options}' +
							premcheckout.currency_selector + 
							'<div class="select-currency" style="display:none;">' +
								'<a href="#" data-currency="usd" class="selected"><i class="fa fa-check" aria-hidden="true"></i><img src="https://s3-us-west-2.amazonaws.com/davidjeremiah.org/site/agentsoftheapocalypse/images/presale/flag_us.png" /> U.S. Dollars</a>' +
								'<a href="#" data-currency="cad"><i class="fa fa-check" aria-hidden="true"></i><img src="https://s3-us-west-2.amazonaws.com/davidjeremiah.org/site/agentsoftheapocalypse/images/presale/flag_cad.png" /> Canadian Dollars</a>' +
							'</div>' +
							'{btns}' +
						'</div>' +
					'</div>' +
					'<div class="checkout-overlay-bg"></div>' +
					'<div class="checkout-test">' +
						'<div class="checkout-box">' +
							'<div class="amount-boxes">' +
								'<div class="amount-box3">' +
									'<span class="currency-symbol">$</span>' +
									'<div class="input-custom-amount"></div>' +
								'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
				'</div>';
	
	var resource_options_html = '<div class="resource-options">' +
									'<a href="#" data-action="yes"><i class="fa fa-circle-o" aria-hidden="true"></i> {opt_in_text}</a>' +
									'<a href="#" data-action="no"><i class="fa fa-circle-o" aria-hidden="true"></i> {opt_out_text}</a>' +
								'</div>';
	resource_options_html = resource_options_html
								.replace('{opt_in_text}', p.OptInText)
								.replace('{opt_out_text}', p.OptOutText);
	//check for GIFT 
	if (product_code=='GIFT') {
		show_resource_options = true;
		resource_options_html = '<div class="recurring-options">' +
									'<a href="#" onclick="premcheckout.toggleRecurringGift(this); return false;"><i class="fa fa-circle-o" aria-hidden="true"></i> Make my donation a monthly gift</a>' +
								'</div>';
	}								
	if (!show_resource_options) {
		resource_options_html = '';
	}
	
	var btns = '<div class="btns">' +
					'<a href="#" class="btn-continue">Continue</a>' +
				'</div>';
	if (tp.payment_method_count > 0) {
		btns = '<div class="btns btns-alt">' +
					'<a href="#" class="btn-oneclick-checkout">1-Click Checkout</a>' +
					'<a href="#" class="btn-continue-alt">or Continue to Standard Checkout</a>' +
				'</div>';
	}
	
	var subtitle = p.OverlaySubtitle;
	subtitle = subtitle.replace('$', '<span class="currency-symbol">' + tp.currency_symbol + '</span>');
	// premcheckout.data.ProductName = p.ProductName;
	html = html.replace('{overlay_title}', p.OverlayTitle)
			   .replace('{overlay_subtitle}', subtitle)
			   .replace(/{amount1}/g, p.AmountOne)
			   .replace(/{amount2}/g, p.AmountTwo)
			   .replace(/{product_code}/g, product_code)
			   .replace('{resource_options}', resource_options_html)
			   .replace('{btns}', btns);
	
	$('body').prepend(html);

	premcheckout.getProductByCode(product_code);
	
	$('.checkout-overlay-fg .amount-box1, .checkout-overlay-fg .amount-box2').off('click').on('click', function() {
		premcheckout.selectAmount(this);
		return false;
	});
	$('.checkout-overlay-fg .amount-box3').off('click').on('click', function() {
		premcheckout.selectAmount(this);		
		$(this).find('input').focus();
		return false;
	});
	$('.checkout-overlay-fg .input-custom-amount').off('keyup').on('keyup', function() {
		var val = premcheckout.filterAmount($(this).val());
		$(this).val(val);
		$('.checkout-test .input-custom-amount').html(val);
		premcheckout.data.amount = val;
		
		var flex_width = $('.checkout-test .input-custom-amount').width();
		if (flex_width > 40 && flex_width < 150) {
			$(this).width(flex_width);
		}
		else if (flex_width <= 40) {
			$(this).width(40);
		}
		else if (flex_width >= 150) {
			$(this).width(150);
		}
	});
	$('.checkout-overlay-fg .resource-options a').off('click').on('click', function() {
		premcheckout.selectResourceOption(this);
		return false;
	});
	
	/* //Removed 11/11/19 - replacing currency selector 
	$('.checkout-overlay-fg .select-currency a').off('click').on('click', function() {
		premcheckout.selectCurrency(this);
		return false;
	});
	*/
	
	$('.checkout-overlay-fg .btn-continue, .checkout-overlay-fg .btn-continue-alt').off('click').on('click', function() {
		premcheckout.submit();
		return false;
	});
	$('.checkout-overlay-fg .btn-oneclick-checkout').off('click').on('click', function() {
		premcheckout.submit({oneclick_checkout:true});
		return false;
	});
	
	if (typeof tp !== 'undefined' && typeof tp.currency !== 'undefined') {
		//premcheckout.selectCurrency(tp.currency);
		premcheckout.updateCurrencyUi(tp.currency);
	}
}

premcheckout.isNewBookProduct = function(product_code) {
	var output = false;
	if (typeof tp.newbook_products !== 'object') return output;
	
	if (tp.newbook_products.indexOf(product_code) != -1) {
		output = true;
	}
	
	return output;
}

premcheckout.doesCartContainNewBookProduct = function() {
	var output = false;
	if (typeof mycart.cart.contents !== 'object') return output;
	if (typeof tp.newbook_products !== 'object') return output;
	
	for (var property in mycart.cart.contents) {
		if (mycart.cart.contents.hasOwnProperty(property)) {
			
			var item = mycart.cart.contents[property];
			if (typeof item.product_code !== 'undefined') {
				var product_code = item.product_code;
				if (tp.newbook_products.indexOf(product_code) != -1) {
					output = true;
					break;
				}
			}

		}
	}
	
	return output;
}

// Get product name using product code for GA4
premcheckout.getProductByCode = function(product_code) {
	var o = {};
	o.product_code = product_code;
	$.post('/api/store/get_product_by_code', o, function(data) {
		if(typeof data === 'object'){
			if(data.success){
				let stamp = ''
				let title = ''
				if(data.product.hasOwnProperty('stamp')) {
					if(typeof data.product.stamp !== 'undefined' && data.product.stamp != null && data.product.stamp != '') {
						stamp = ' ' + data.product.stamp.trim();
					}
				}
				title = data.product.title + stamp;
				title = title.replace(/^\s+|\s+$|\s+(?=\s)/g, "");
				premcheckout.data.ProductName = title;
				$('.checkout-overlay-wrapper').addClass('visible');
			}
		}
	});
}

premcheckout.doesCartContainNonNewBookProduct = function() {
	var output = false;
	if (typeof mycart.cart.contents !== 'object') return output;
	if (typeof tp.newbook_products !== 'object') return output;
	
	var gift_product_codes = ["GIFT", "APIXMLTR", "APXMLTR", "BSPXMLTR", "PCXMLTR", "VCSMLTR"];
	
	for (var property in mycart.cart.contents) {
		if (mycart.cart.contents.hasOwnProperty(property)) {
			
			var item = mycart.cart.contents[property];
			if (typeof item.product_code !== 'undefined') {
				var product_code = item.product_code;
				if (tp.newbook_products.indexOf(product_code) == -1 
					&& gift_product_codes.indexOf(product_code)==-1
					&& product_code.substring(0,3)!='SGR') {
						output = true;
					break;
				}
			}

		}
	}
	
	return output;
}

premcheckout.getCartProductCount = function() {
	var output = 0;
	if (typeof mycart.cart.contents !== 'object') return output;
	
	for (var property in mycart.cart.contents) {
		output = (output + 1);
	}
	
	return output;
}

premcheckout.clearData = function() {
	premcheckout.data.product_code = '';
	premcheckout.data.min_amount = '';
	premcheckout.data.amount = '';
	premcheckout.data.receive_resources = null;
}

premcheckout.selectAmount = function(elem) {
	$('.checkout-overlay-fg .amount-boxes > div').removeClass('selected');
	$(elem).addClass('selected');
	
	//get amount 
	var amount = $(elem).attr('data-amount');
	if ($(elem).hasClass('amount-box3')) {
		amount = premcheckout.filterAmount($(elem).find('input').val());
	}
	
	//log amount 
	if (typeof amount !== 'undefined') {
		premcheckout.data.amount = amount;
	}
}

premcheckout.filterAmount = function(amount) {
	var output = amount.toString();
	output = output.replace(/[^0-9.,]/g, '');
	return output;
}

premcheckout.selectResourceOption = function(elem) {
	$('.checkout-overlay-fg .resource-options a').find('.fa').removeClass('fa-check-circle').addClass('fa-circle-o');
	$(elem).find('.fa').removeClass('fa-circle-o').addClass('fa-check-circle');
	
	var action = $(elem).attr('data-action');
	premcheckout.data.receive_resources = action;
}

/*
premcheckout.selectCurrency = function(elem) {
	if (typeof elem === 'string') {
		var currency_code = elem.toLowerCase();		
		$('.checkout-overlay-fg .select-currency a').each(function() {
			var data_currency = $(this).attr("data-currency");
			if (data_currency == currency_code) {
				elem = this;
			}
		});
	}

	$('.checkout-overlay-fg .select-currency a').removeClass('selected');
	$(elem).addClass('selected');
	
	var currency = $(elem).attr('data-currency');
	premcheckout.data.currency = currency;
	
	switch(currency.toLowerCase()) {
		case 'usd':
			$('.currency-desc').html('');
			break;
		case 'cad':
		default:
			$('.currency-desc').html(currency.toUpperCase());
			break;
	}
}
*/

premcheckout.updateCurrencyUi = function(elem) {	
	
	if (typeof elem === 'string') {
		var dropdown_elem = null;
		$('.checkout-overlay-wrapper .currencies_wrapper ul li a').removeClass('selected');
		$('.checkout-overlay-wrapper .currencies_wrapper ul li').each(function() {
			var a = $(this).find('a');
			if (a.attr('data-currency').toLowerCase() == elem.toLowerCase()) {
				dropdown_elem = a;
				$(a).addClass('selected');
			}
		});
		elem = dropdown_elem;
		$('.checkout-overlay-wrapper .currencies_wrapper .selected-currency img')
			.attr('src', $(elem).find('img').attr('src'))
			.attr('alt', $(elem).find('img').attr('alt'))
			.attr('title', $(elem).find('img').attr('title'));
	}

	var parent = $(elem).closest('.checkout-box');
	
	var o = {};
	o.currency = $(elem).attr("data-currency");
	o.currency_symbol = $(elem).attr("data-currency-symbol");
	o.currency_symbol_original = o.currency_symbol;
	
	switch(o.currency.toLowerCase()) {
		case "cad":
			o.currency_symbol = '$';
			$(parent).find('.currency-desc').html('CAD').show();
			break;
		default:
			$(parent).find('.currency-desc').hide();
			break;
	}
	
	$(parent).find('.currency-symbol').html( o.currency_symbol );
	
	if (typeof mycart !== 'undefined') {
		mycart.setCurrency(o.currency, function(){}, {currency_symbol: o.currency_symbol_original});
	}
}

premcheckout.showError = function(error_msg) {
	$('.checkout-overlay-fg .error-msg').stop().html(error_msg).slideDown(200);
}

premcheckout.hideError = function() {
	$('.checkout-overlay-fg .error-msg').stop().slideUp(200, function() {
		$(this).html('');
	});
}

premcheckout.submit = function(settings) {
	
	if (typeof settings === 'undefined') settings = {};
	if (typeof settings.oneclick_checkout === 'undefined') settings.oneclick_checkout = false;
	if (typeof settings.preprocess_function === 'undefined') settings.preprocess_function = '';
	
	var error_msg = '';
	premcheckout.hideError();
	
	//if GIFT is product, ensure recurring-giving product code exists in resourcedata
	premcheckout.addRecurringGiftProductCode();
	
	//determine product code 
	var product_code = premcheckout.data.product_code;
	var p = resourcedata.resources[product_code];
	switch(premcheckout.data.receive_resources) {
		case 'yes':
			product_code = premcheckout.data.product_code;
			premcheckout.data.min_amount = resourcedata.resources[product_code].MinimumDonationAmount;
			break;
		case 'no':
			product_code = 'GIFT';
			premcheckout.data.ProductName = "Generous Donation"
			premcheckout.data.min_amount = 0.01;
			break;
	}	


	
	//validate product code 
	if (product_code == '') {
		error_msg = 'Sorry, we couldn\'t find the product you requested.';
		premcheckout.showError(error_msg);
		return;
	}
	
	//validate amount 
	if (premcheckout.data.amount == '' || parseFloat(premcheckout.data.amount) < parseFloat(premcheckout.data.min_amount)) {
		error_msg = 'Please enter a valid donation amount.';
		if (typeof p.AmountValidationError !== 'undefined') {
			error_msg = p.AmountValidationError;
		}
		premcheckout.showError(error_msg);
		return;
	}
	
	//validate resource options 
	var show_resource_options = true;
	if (typeof p.ShowResourceOptions !== 'undefined') {
		show_resource_options = p.ShowResourceOptions;
	}
	if (show_resource_options && (premcheckout.data.receive_resources == null || premcheckout.data.receive_resources == '')) {
		error_msg = 'Please indicate if you would like to receive the gift.';
		premcheckout.showError(error_msg);
		return;
	}
	
	//check for preprocess_function 
	if (settings.preprocess_function != '') {
		settings.preprocess_function();
		return;
	}

	let dataLayerData = { 
		"currency": tp.currency,
		"value": premcheckout.data.amount,
		"items": [{
			"item_name":premcheckout.data.ProductName,
			"item_id":product_code,
			"quantity": 1,
			"index": 0,
			"price": premcheckout.data.amount,
		}]
	};


	dataLayer = window.dataLayer || [] 
	dataLayer.push(
		{
			event: "view_item",
			ecommerce: dataLayerData
		}
	); 
	
	tp.addToCart(product_code, 1, {
		replace_qty: true,
		custom_price: premcheckout.data.amount,
		currency: tp.currency,
		exclude_page: true,
		callback: function(data) {
			if (typeof data === 'object' && typeof data.contents === 'object') {
				
				premcheckout.hide();
				
				var i = 0;
				for (var pc in data.contents) {
					if (data.contents.hasOwnProperty(pc)) {
						i++;
					}
				}
				
				if (i>0 || settings.oneclick_checkout) {
					
					//show cart
					mycart.cart.cart_id = data.cart_id;
					mycart.cart.contents = data.contents;
					//mycart.currency = data.currency;
					//mycart.cart.currency = data.currency;
					mycart.cart.item_count = data.item_count;
					mycart.cart.page_settings = data.page_settings;
					mycart.cart.shipping = data.shipping;
					mycart.cart.subtotal = data.subtotal;
					mycart.cart.tax = data.tax;
					mycart.cart.total = data.total;
					mycart.setCurrency(data.currency, '', {use_ajax:false, currency_symbol:tp.currency_symbol});

					if (settings.oneclick_checkout) {
						mycart.showCart({oneclick_checkout: settings.oneclick_checkout, headline: '1-Click Checkout'});
					}
					else {
						mycart.showCart();
					}
				}
				else {
					//go directly to checkout 
					window.location.href = '/checkout?c=' + premcheckout.data.currency;
				}

			}
			else {
				alert('Sorry, we encountered an error.  Please try again.');
			}
		}
	});
	
}

premcheckout.hide = function() {
	$('.checkout-overlay-wrapper').removeClass('visible');
	setTimeout(function() {
		$('.checkout-overlay-wrapper').remove()
	}, 250);
}

premcheckout.removeTags = function(str) {
    if ((str===null) || (str===''))
        return false;
    else
        str = str.toString();
    return str.replace( /(<([^>]+)>)/ig, '');
}

premcheckout.close = function() {
	$('.checkout-overlay-wrapper').removeClass('visible');
	setTimeout(function() {
		$('.checkout-overlay-wrapper').remove();
		if(premcheckout.data.product_code == 'GIFT') {
			premcheckout.data.ProductName = "Generous Donation"
		}
		var product_code = premcheckout.data.product_code;
		var amount = premcheckout.data.min_amount;
		if(premcheckout.data.receive_resources != null) {
			switch(premcheckout.data.receive_resources) {
				case 'no':
					product_code = 'GIFT';
					premcheckout.data.ProductName = "Generous Donation"
					premcheckout.data.min_amount = 0.01;
					break;
			}
		}

		if(premcheckout.data.amount !='') {
			amount = premcheckout.data.amount;
		}

		var dataLayerData = { 
			"currency": tp.currency,
			"value": amount,
			"items": [{
				"item_name":premcheckout.data.ProductName,
				"item_id":product_code,
				"quantity": 1,
				"index": 0,
				"price": amount,
			}]
		};
		dataLayer = window.dataLayer || [] 
		dataLayer.push(
			{
				event: "view_item",
				ecommerce: dataLayerData
			}
		); 
	}, 250);
}



premcheckout.addRecurringGiftProductCode = function() {
	if (typeof resourcedata.resources['APXMLTR'] === 'undefined') {
		var o = {
			"AmountOne": 40,
			"AmountTwo": 50,
			"CheckoutPageUrl": "/checkout",
			"MinimumDonationAmount": 0.01,
			"OptInText": "",
			"OptOutText": "",
			"OverlaySubtitle": "With a Recurring Gift of Any Amount",
			"OverlayTitle": "Support Turning Point",
			"ScrollTo": ".scroll_gift",
			"ShowResourceOptions": false
		}
		resourcedata.resources['APXMLTR'] = o;
	}
}

premcheckout.toggleRecurringGift = function(elem) {
	if ($(elem).find('.fa').hasClass("fa-circle-o")) {
		//select recurring 
		premcheckout.data.product_code = 'APXMLTR';
		
		$(elem).find('.fa').removeClass('fa-circle-o').addClass('fa-check-circle');
	}
	else {
		//select single GIFT
		premcheckout.data.product_code = 'GIFT';
		
		$(elem).find('.fa').addClass('fa-circle-o').removeClass('fa-check-circle');
	}
}

function getQueryStringValue(key) {
	return decodeURIComponent(window.location.search.replace(new RegExp("^(?:.*[&\\?]" + encodeURIComponent(key).replace(/[\.\+\*]/g, "\\$&") + "(?:\\=([^&]*))?)?.*$", "i"), "$1"));  
}

function scrollToElem(elem, callback) {
	var nav = $(".nav");
	var nav_is_fixed = (( nav.css("position")=="fixed" ) ? true : false);
	var offset = ((nav_is_fixed) ? nav.height() : 0);

	$('html, body').animate({
		scrollTop: ($(elem).offset().top - offset)
	 }, 600, function() {
		if (typeof callback === 'function') {
			callback();
		}
	 });
}